#! /usr/bin/env python

from Tree import Tree
from Token import Token
from TokenTree import TokenTree
"""
tok = Token('A', Token.NODENAME)
print tok
tree = TokenTree(tok)
print tree
"""
class ToyTree(Tree):
    def __init__(self, nest):
        self.immobilized = False
        self.addnest('TOP', nest)

    def addnest(self, parent, nest):
        if not isinstance(nest[0], str):
            raise TypeError, 'first item is each tuple in nest must be a string'
        newparent = Token(nest[0], Token.NODENAME)
        self.addnode(newparent, parent)
        for obj in nest[1:]:
            if isinstance(obj, str):
                tok = Token(obj, Token.NODENAME)
                self.addnode(tok, newparent)
            else:
                self.addnest(newparent, obj)

    def match(self, pattern, startnode=None):
        for node, parents in toy.walk_parents(startnode):
            if parents == pattern:
                yield node

if __name__ == '__main__':
#    nest = ('A', ('H', 'd', ('J', 'j')), ('B', 'b'), ('C', 'x'))
    nest = ('A', ('H', 'd'), ('J', 'j'), ('B', 'b'), ('C', 'x'))
#    nest = ('A', 'c', ('B', 'd'))
    toy = ToyTree(nest)
    print repr(toy)

    """
    for node, parentlist in toy.walk_parents():
        print parentlist
    for node in toy.match(['A', 'H']):
        print node
    """