#! /usr/bin/env python

import inspect

text = """\
def fun(i):
    print i+2
    x.y
"""
"""
# This works if I know the name of the function when I am writing the code.
exec text in globals(), locals()
print locals()['fun']
fun(5)

# Or if I know the name of the function at run time.
locals()['fun'](5)
"""
d = dict()
exec text in globals(), d
print d
name = d.keys()[0]
f = d[name]
#f(5)
#f.__call__(5)

print '========='
pairs = inspect.getmembers(f)
for a,b in pairs:
    print a
    print '   ', b

text2 = """\
def outer():
    def fun(i):
        print i+2
    return fun
"""
"""
exec text2 in globals(), locals()
f = outer()
f(5)
"""