#! /usr/bin/env python

import tokenize
from LN import LN, MLLN

#f = open('indent.test', 'r')
f = open('CREATORtest', 'r')

prevlinenum = -1
for token in tokenize.generate_tokens(f.readline):
#    print token
    code = token[0]
    text = token[4].rstrip()
    if code == 5:
        print 'INDENT', text
    if code == 6:
        print 'DEDENT', text
    linenum = token[2][0]
    if linenum > prevlinenum and \
           (text.startswith('TEMPLATE') or text.startswith('CODE') or
            text.startswith('ENDTEMPLATE') or text.startswith('STUB') or
            text.startswith('CREATOR')):
        print text.rstrip()
    prevlinenum = linenum
