#! /usr/bin/env python

def makeprop(truename, funname):
    def fget(self):
        setattr(self, truename, getattr(self, funname)())
        return getattr(self, truename)
    return property(fget, None, None)

class X(object):
    i = makeprop('_i', 'Fi')

    def __init__(self, k):
        self.k = k

    def Fi(self):
        return self.k

x = X(11)
print x.i
