#! /usr/bin/env python

from distutils.core import setup
from distutils.extension import Extension
from Pyrex.Distutils import build_ext
import shutil

setup(
  name = 'Example',
  ext_modules=[
    Extension("pyExample", ["pyExample.pyx", "example.c"]),
    ],
  cmdclass = {'build_ext': build_ext}
)

shutil.copy('build/lib.linux-i686-2.3/pyExample.so', '.')
