ctypedef int size_t

cdef extern from "stdlib.h":
    void* malloc(size_t size)
    void free(void* ptr)

cdef extern from "stdio.h":
    int printf(char* format, ...)

cdef extern from "Python.h":
    void* PyMem_Malloc(size_t n)
    void* PyMem_Realloc(void *p, size_t n)
    void PyMem_Free(void *p)
    # ...

cdef extern from "example.h":
    int funct(int n, int* arr)

def pyfunct(pylist):
    cdef int i, n, k, m
    cdef int * arr
    n = len(pylist)
    arr = <int*> malloc(n * sizeof(int))
    for i in range(n):
        k = pylist[i]
        arr[i] = k
    m = funct(n, arr)
    free(arr)
    return m


