#! /usr/bin/env python

from LN import LN, MLLN

class C:
    mytype = 'C'
    def C_method(self, foo):
        LN(C.mytype, foo)

def TClass(T):
    class TClass(T):
        mytype = ('TClass', T.__name__)

        def TClass_method(self, bar):
            LN(TClass.mytype, bar)

        def __str__(self):
            return '<TClass: %s>' % str(int(self))

        def __repr__(self):
            return '<TClass: %s>' % repr(int(self))

    # T is a base class of TClass.
    return TClass

TC_int = TClass(int)
LN(TC_int)

TC_int_instance = TC_int(66)
LN(TC_int_instance)
TC_int_instance.TClass_method('abc')
