#! /usr/bin/env python

import sys

if len(sys.argv) != 2:
    print >> sys.stderr, 'USAGE: ./quickindent.py <file>'
    sys.exit(0)
name = sys.argv[1]
text = file(name + '.data', 'r').read()
text = text.replace('"("', '"LP"')
text = text.replace('")"', '"RP"')
depth = 0
out = []
words = text.split()
for word in words:
    if word[0] == '(':
        out.append('\n' + depth*' ')
        out.append(word)
        depth += 1
    elif len(word) > 1 and word[-2] == ')':
        depth -= 1
        out.append('\n' + depth*' ' + ')')
        out.append(word[:-2] + ' ')
    elif word[-1] == ')':
        depth -= 1
        out.append('\n' + depth*' ' + ')')
        out.append(word[:-1])
    else:
        out.append(word)
text = ''.join(out)
text = text.replace('"LP"', '"("')
text = text.replace('"RP"', '")"')
text = text.replace('","', '", "').strip()
print text
