#! /usr/bin/env python

import sys

def unstripit(ppsfile, tmpsrcfile, srcfile):
    """Puts back in the processor directives removed by "strip_preprocs.stripit"."""
    text = open(ppsfile, 'r').read()
    pps = eval(text, dict(), dict())  # pysco want the dicts.
    lines = open(tmpsrcfile, 'r').read().splitlines()
    length = pps[0]
    if len(lines) < pps[0]:
        nls = [''] * (pps[0] - len(lines))
        lines.extend(nls)
    for i, directive in pps[1:]:
        if i >= len(lines) or lines[i].strip() != '':
            print 'L11', i, len(lines)
            raise ValueError, 'mismatch between ".pps" file and ".tmpsrc" file'
        lines[i] = directive
    lines.append('')
    text = '\n'.join(lines)
    open(srcfile, 'w').write(text)

if __name__ == '__main__':
    if len(sys.argv) != 2:
        sys.exit('USAGE: ./unstrip_preprocs.py <filename>')
    tmpsrcfile = sys.argv[1] + '.tmpsrc'
    ppsfile = sys.argv[1] + '.pps'
    srcfile = sys.argv[1] + '.src'
    unstripit(ppsfile, tmpsrcfile, srcfile)
