#! /usr/bin/env python

import sys

# Reformats a error file. Used in "pyrexmake".

if len(sys.argv) != 2:
    print >>sys.stderr, 'program requires an argument'
fileerrors = sys.argv[1] + '.errors'

filename = '/home/edcjones/cvlib/antlr/cgram/mystuff/pyrex4/wrapped.pyx:'
lenfn = len(filename)

lines = file(fileerrors, 'r').read().splitlines()
if len(lines) != 0:
    print >> sys.stderr, 'Errors found'
    out = []
    for line in lines:
        if line.startswith(filename):
            out.append(line[lenfn:])
        else:
            out.append(line)
    text = '\n'.join(out)
    file(fileerrors, 'w').write(text)
