#! /usr/bin/env python

class NoMatchException(Exception):
    pass

class NOMATCH:
    pass

class Tree:
    def __init__(self):
        self.cache = dict()
        self.patterns = dict()

cache = dict()
patterns = dict()

text = """\
def outer(apattern):
    patterns['fun'] = apattern
    # "inner" runs the cache. Both successes and failures are cached.
    def inner(tree, i):
        # The pattern is put into a variable visible inside "fun".
        pattern = patterns['fun']
        def fun(tree, n):
            print 'Function called:',
            if n == 17:
                raise NoMatchException
            return pattern % n

        if ('fun', i) not in cache:
            try:
                cache[('fun', i)] = fun(tree, i)
            except NoMatchException:
                cache[('fun', i)] = NOMATCH
        else:
            print 'Cache used:',
        if cache[('fun', i)] == NOMATCH:
            raise NoMatchException, 'matching failed in %s(%s)' % ('fun', i)
        return cache[('fun', i)]
    return inner
"""
exec text
apattern = '<<%s>>'
Tree.__dict__['fun'] = outer(apattern)

tree = Tree()
print tree.fun(7)
print tree.fun(11)
print tree.fun(7)
try:
    print tree.fun(17)
except NoMatchException, x:
    print x
try:
    print tree.fun(17)
except NoMatchException, x:
    print x
