ctypedef int size_t

cdef extern from "stdlib.h":
    void* malloc(size_t size)
    void free(void* ptr)

cdef extern from "stdio.h":
    int printf(char* format, ...)

cdef extern from "Python.h":
    void* PyMem_Malloc(size_t n)
    void* PyMem_Realloc(void *p, size_t n)
    void PyMem_Free(void *p)
    # ...

# Do not forget this.
cdef extern from "example.h":
    int* funct(int n, int* arrin)

cdef union value:
    unsigned char u_char
    unsigned short u_short
    unsigned int u_int
    unsigned long u_long
    unsigned long long u_longlong
    signed char s_char
    signed short s_short
    signed int s_int
    signed long s_long
    signed long long s_longlong
    float flt
    double dbl
