ctypedef int size_t

cdef extern from "stdlib.h":
    void* malloc(size_t size)
    void free(void* ptr)

cdef extern from "stdio.h":
    int printf(char* format, ...)

cdef extern from "Python.h":
    void* PyMem_Malloc(size_t n)
    void* PyMem_Realloc(void *p, size_t n)
    void PyMem_Free(void *p)
    # ...

# Do not forget this.
cdef extern from "example.h":
    int* funct(int n, int* arrin)

# Lists of ints only.
cdef int* pylist2carray(object pylist):
    cdef int* carr
    cdef int i, k, n 
    cdef object pyi

    n = len(pylist)
    carr = <int*> malloc( n * sizeof(int))
    for i from 0 <= i < n:
         carr[i] = pylist[i]
#        pyi = i
#        k = pylist[pyi]  # Conversion
#        carr[i] = k
    return carr

cdef object carray2pylist(int n, int* carr):
    cdef int i
    cdef object pyk
    cdef object pylist

    pylist = []
    for i from 0 <= i < n:
        pylist.append(carr[i])
#        pyk = carr[i]
#        pylist.append(pyk)
    return pylist

def pyfunct(object pylist):
    cdef int* carr
    cdef int* carr2
    cdef int i, n
    cdef object pyout, pyn, pylist2

    pyn = len(pylist)
    n = pyn  # Conversion.
    carr = pylist2carray(pylist)
    carr2 = funct(n, carr)
    pylist2 = carray2pylist(n, carr2)
    free(carr2)
    free(carr)
    return pylist2
